unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShellApi, IniFiles, ComCtrls, Gauges, ShlObj;

type
  TForm1 = class(TForm)
    EditSource: TEdit;
    EditOut: TEdit;
    Button2: TButton;
    Button4: TButton;
    Button5: TButton;
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);

  private
    { Private declarations }
   public
    { Public declarations }
  end;

var
  Form1: TForm1;
  AppDir,Opts,Opto,s:string; //  
  IniFile:TIniFile; //   
implementation

uses Unit2;

{$R *.dfm}

procedure CallBack(wnd: hWnd; uMsg: UINT; lParam, lpData: LParam) stdcall;
begin
  SendMessage(wnd, BFFM_ENABLEOK, 0, 1);
end;



// 
procedure TForm1.Button2Click(Sender: TObject);
begin
//  
  IniFile := TIniFile.Create(AppDir+'config.INI'); {    }
//     
  IniFile.WriteString('Options' , 'Source', Editsource.Text);
  IniFile.WriteString('Options' , 'Out', Editout.Text);
//     ,       
  Opts:=IniFile.ReadString('Options','Source','Anonimous');
  Opto:=IniFile.ReadString('Options','Out','Anonimous');
  IniFile.Free; {  ,      }
ShowMessage('    !');
  Close();
end;

 //  
procedure TForm1.FormCreate(Sender: TObject);
begin
//    
AppDir:=ExtractFilePath(Application.ExeName);
//  
IniFile := TIniFile.Create(AppDir+'config.INI');
//     
Opts:=IniFile.ReadString('Options','Source','Anonimous');
Opto:=IniFile.ReadString('Options','Out','Anonimous');
//   
Editsource.Text:=Opts;
Editout.Text:=Opto;
end;

///
procedure TForm1.Button4Click(Sender: TObject);
var
  bi: TBrowseInfo;
  s: PChar;
  PIDL, ResPIDL: PItemIDList;
begin
  SHGetSpecialFolderLocation(Form1.Handle, CSIDL_DESKTOP, PIDL);
  s := StrAlloc(128);
  bi.hwndOwner := Form1.Handle;
  bi.pszDisplayName := s;
  bi.lpszTitle := ' ';
  bi.pidlRoot := PIDL;
  bi.lpfn := addr(CallBack);
  ResPidl := SHBrowseForFolder(BI);
  SHGetPathFromIDList(ResPidl, s);
  EditSource.Text := s;
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  bi: TBrowseInfo;
  s: PChar;
  PIDL, ResPIDL: PItemIDList;
begin
  SHGetSpecialFolderLocation(Form1.Handle, CSIDL_DESKTOP, PIDL);
  s := StrAlloc(128);
  bi.hwndOwner := Form1.Handle;
  bi.pszDisplayName := s;
  bi.lpszTitle := ' ';
  bi.pidlRoot := PIDL;
  bi.lpfn := addr(CallBack);
  ResPidl := SHBrowseForFolder(BI);
  SHGetPathFromIDList(ResPidl, s);
  EditOut.Text := s;
end;

end.
